#include "FromSuperBrain.h"


#include "CurlHttp.h"
#include "fmt/format.h"


FromSuperBrain::FromSuperBrain()
{
    m_logger = spdlog::get("FromSuperBrain");
    if(m_logger == nullptr)
    {
        SPDLOG_ERROR("FromSuperBrain logger is nullptr");
        return;
    }

    m_url = "http://172.16.36.80:30000/vos";
}

FromSuperBrain::~FromSuperBrain()
{

}

/* 获取token */
bool FromSuperBrain::getToken()
{
    std::string response;
    std::string httpBody = R"({"appSecret":"8zR9ug4WbKCtEgaQ08myRm5HqKIMwP83Ra24t921tO/mU0cTIFdm/t0C9Jxrd53x","appKey":"rili4l26"})";
    std::vector<std::string> vecHeader;
    vecHeader.push_back("Content-Type: application/json");
    std::string url = m_url + m_tokenPath;
    if(!CurlHttp::Post(url, vecHeader, httpBody, response))
    {
        SPDLOG_LOGGER_ERROR(m_logger, "Get Token failed");
        return false;
    }
    SPDLOG_LOGGER_DEBUG(m_logger, "response:{}", response);
    m_token = response;

    return true;
}


/* 获取算法列表 */
bool FromSuperBrain::getTaskTypeList()
{
    if(m_token.empty())
    {
        SPDLOG_LOGGER_ERROR(m_logger, "Token is empty");
        return false;
    }
    std::string response;
    std::vector<std::string> vecHeader;
    vecHeader.push_back(fmt::format("accessToken: {}", m_token));
    std::string url = m_url + m_taskTypeListPath;
    if(!CurlHttp::Get(url, vecHeader, response))
    {
        SPDLOG_LOGGER_ERROR(m_logger, "Get TaskTypeList failed");
        return false;
    }
    SPDLOG_LOGGER_DEBUG(m_logger, "response:{}", response);
    m_taskTypeList = response;

    return true;
}

/* 获取设备列表信息 */
bool FromSuperBrain::getDeviceList()
{
    if(m_token.empty())
    {
        SPDLOG_LOGGER_ERROR(m_logger, "Token is empty");
        return false;
    }
    std::string response;
    std::vector<std::string> vecHeader;
    vecHeader.push_back(fmt::format("accessToken: {}", m_token));
    std::string url = m_url + m_deviceListPath;
    if(!CurlHttp::Get(url, vecHeader, response))
    {
        SPDLOG_LOGGER_ERROR(m_logger, "Get TaskTypeList failed");
        return false;
    }
    SPDLOG_LOGGER_DEBUG(m_logger, "response:{}", response);

    return true;
}

