#ifndef FROMSUPERBRAIN_H
#define FROMSUPERBRAIN_H

#include <string>

#include "spdlog/spdlog.h"

class FromSuperBrain
{
public:
    FromSuperBrain();
    ~FromSuperBrain();
    /* 获取token */
    bool getToken();
    /* 获取算法列表 */
    bool getTaskTypeList();
    /* 获取设备列表信息 */
    bool getDeviceList();

private:
    std::shared_ptr<spdlog::logger> m_logger = nullptr;

    std::string m_url;
    std::string m_username;
    std::string m_password;

    std::string m_token;                            /* token */
    std::string m_taskTypeList;                     /* 任务类型列表 */
    const std::string m_tokenPath = "/external/broadcastToken";              /* 获取token数据 */
    const std::string m_taskTypeListPath = "/external/getTaskTypeList";      /* 获取任务类型数据 */
    const std::string m_deviceListPath = "/external/getBaseDeviceList";      /* 获取设备列表数据 */
};


#endif /* FROMSUPERBRAIN_H */
