#include "ToEQMDataBase.h"



ToEQMDataBase::ToEQMDataBase()
{
    m_logger = spdlog::get("ToEQMDataBase");
    if(m_logger == nullptr)
    {
        SPDLOG_ERROR("ToEQMDataBase logger is nullptr");
        return;
    }
}

ToEQMDataBase::~ToEQMDataBase()
{
    if(m_httpApi != nullptr)
    {
        delete m_httpApi;
        m_httpApi = nullptr;
    }
}


/* 初始化WebApi */
bool ToEQMDataBase::initWebApi(const QString& url,const QString& serverIP,const QString& serID)
{
    if(m_httpApi == nullptr)
    {
        m_httpApi = new lhhttpapi;
    }
    int ret = 0;

    ret = m_httpApi->DBQInit(url);
    if(ret < 0)
    {
        SPDLOG_LOGGER_ERROR(m_logger,"Init WebApi failed:{}, error Info:{}",ret,m_httpApi->DoGetLastError(&ret).toStdString());
        return false;
    }
    // SPDLOG_LOGGER_TRACE(m_logger,"初始化WebApi成功!");
    QString serverList;
    ret = m_httpApi->DBQGetServerList(serverList);
    if(ret < 0)
    {
        SPDLOG_LOGGER_DEBUG(m_logger,"Get server list failed:{}, error info:{}",ret,m_httpApi->DoGetLastError(&ret).toStdString());
        return false;
    }
    SPDLOG_LOGGER_TRACE(m_logger,"Server list:{}",serverList.toStdString());
    SPDLOG_LOGGER_DEBUG(m_logger,"WebAPI Sucess!");
    /* 登录 */
    ret = m_httpApi->DBQLogin(serverIP, serID, "EQM_MG", m_userToken);
    if(ret < 0)
    {
        SPDLOG_LOGGER_ERROR(m_logger,"Login failed:{}, error info:{}",ret,m_httpApi->DoGetLastError(&ret).toStdString());
        return false;
    }
    SPDLOG_LOGGER_TRACE(m_logger,"Login sucess!");

    return true;
}

